<?php

require_once 'base/FpaincideventoEntityBase.php';

/**
 * FpaincideventoEntity.
 *
 * @package Entity
 *
 * @author  alessandrobartels
 *
 */
class FpaincideventoEntity extends FpaIncideventoEntityBase
{
    private static $_incidencias = array();


    /**
     * Enter description here ...
     *
     * @param TkDateTime $data_competencia Data de competencia.
     *
     * @return void
     *
     * @author alessandrobartels
     *         alessandrobartels 25/02/12 - o vetor de incidencias passa a receber IDINCIDEVENTO
     */
    public static function inicializaLista(TkDateTime $data_competencia) {
        $incidencias = Fpaincidevento::retornaIncidencias($data_competencia);
        foreach ($incidencias as $incidencia) {
            // self::$_incidencias[$incidencia->getNrtipoincide()][$incidencia->getNreventom()] = true;
            $idIncidevento = $incidencia->getIdincidevento();
            self::$_incidencias[$incidencia->getNrtipoincide()][$incidencia->getNreventom()] = $idIncidevento;
        }
    }


    /**
     * Enter description here ...
     *
     * @param integer    $tipo_incidencia  Numero do tipo de incidencia.
     * @param integer    $nr_evento        Numero do evento.
     * @param TkDateTime $data_competencia Data de competencia.
     *
     * @return boolean | int
     *
     * @author alessandrobartels
     */
    public static function incide($tipo_incidencia, $nr_evento, TkDateTime $data_competencia){

        if (empty(self::$_incidencias) === true) {
            self::inicializaLista($data_competencia);
        }

        if (array_key_exists($tipo_incidencia, self::$_incidencias) === true) {
            if (array_key_exists($nr_evento, self::$_incidencias[$tipo_incidencia]) === true) {
                return self::$_incidencias[$tipo_incidencia][$nr_evento];
            } else {
                return false;
            }
        } else {
            return false;
        }

    }


    public static function getEventos($mesCompentencia, $tipoIncidencia){
        $nrEventos = array();

        if (empty(self::$_incidencias) === true) {
            self::inicializaLista($mesCompentencia);
        }

        if (array_key_exists($tipoIncidencia, self::$_incidencias) === true) {
            foreach(self::$_incidencias[$tipoIncidencia] as $nrEvento =>$incideEvento){
                $nrEventos[] = $nrEvento;
            }
        }

        return $nrEventos;
    }



}

